Index: examples/python_tests/alumni2_rt1/query.py
===================================================================
--- examples/python_tests/alumni2_rt1/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni2_rt1/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -14,10 +14,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 stateUID=ABAC.ID("StateU_ID.pem")
 stateUID.id_load_privkey_file("StateU_private.pem")
@@ -37,4 +41,17 @@
 
 ##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
+# is bob a founding alumni of stateU ?
 # role=[keyid:stateU].role:foundingAlumni
 # p=[keyid:Bob] 
@@ -47,4 +64,5 @@
 
 ##########################################################################
+# is maryann a founding alumni of stateU ?
 # role=[keyid:stateU].role:foundingAlumni
 # p=[keyid:Maryann] 
@@ -57,4 +75,5 @@
 
 ##########################################################################
+# is joe a founding alumni of stateU ?
 # role=[keyid:stateU].role:foundingAlumni
 # p=[keyid:Joe] 
@@ -65,18 +84,2 @@
 for c in out[1]:
     print "%s <- %s" % (c.head_string(), c.tail_string())
-
-##########################################################################
-# dump the loaded principals/policies
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
-
-
Index: examples/python_tests/alumni2_rt1/run_test
===================================================================
--- examples/python_tests/alumni2_rt1/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni2_rt1/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,6 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
 
 echo '---setup principals'
Index: examples/python_tests/alumni2_rt1/setup.py
===================================================================
--- examples/python_tests/alumni2_rt1/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni2_rt1/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,6 +2,6 @@
 
 """
-  Setup 4 principal ID credentials
-
+See README for the semantics.  This creates 4 principals
+used by the example.
 """
 import os
Index: examples/python_tests/alumni3_rt1/README
===================================================================
--- examples/python_tests/alumni3_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni3_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,90 +1,40 @@
-#!/bin/sh
 #
-# This example shows an example of reasoning about a role's parameters.  There
-# are 4 principals StateU, Bob, Mark, Maryann, Joe, and Jan.  StateU wants to
-# establish a set of founding alumni based on the year of graduation.  On
-# graduation each alum has previously been issued a credential parameterized
-# with their major and graduation year.  StateU sets up a policy that says that
-# a principal is a founding alum if they graduated in 1960, 1961, or 1963 in
-# either mathematics or psychology.  One assumes there was some kind of NCAA
-# suspension in 1962.  This policy is expressed in Credential 1.
+# This example shows an example of reasoning about a role's parameters with
+# range constraints.  There are 6 principals StateU, Bob, Mark, Maryann, 
+# Joe, and Jan.  StateU wants to establish a set of founding alum 
+# based on the year of graduation.  On graduation each alum has previously 
+# been issued a credential parameterized with their major and graduation year.
+# StateU sets up a policy that says that  a principal is a founding alumni
+# if they graduated in 1960, 1961, or 1963 in either mathematics or psychology
+# only.  One assumes there was some kind of NCAA suspension in 1962.  This 
+# policy is expressed in Credential 1.
 #
 # Credentials 2, 3, 4, 5, and 6 each assign a diploma credential to Bob (a 1961
-# mathematics degree), Mark (a 1965 mathematics degree), Joe (a 1961 zoology degree), Maryann (a 1962 psychology degree), and Jan (a 1960 psychology degree)
+# mathematics degree), Mark (a 1965 mathematics degree), Joe (a 1961 zoology degree),
+# Maryann (a 1962 psychology degree), and Jan (a 1960 psychology degree)
 #
-# The attached ./run_query file asks if each of these principals are favored
-# alums, and only Bob and Jan are.
+# The query.py asks if each of these principals are favored alums, and only 
+# Bob and Jan are.
 
-# alumni3_rt1_typed
+# alumni3_rt1
 
-rm -rf *.der *.pem
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Bob] (yes)
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Maryann] (no)
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Joe] (no)
+# Credential 1
+# [keyid:stateU].role:foundingAlumni 
+#              <- [keyid:stateU].role:diploma([string:?D:['mathmatics','psychology']],
+#                                        [integer:?Year:[1960,1961,1963]])
 
-creddy --generate --cn StateU
-creddy --generate --cn Bob
-creddy --generate --cn Mark
-creddy --generate --cn Joe
-creddy --generate --cn Maryann
-creddy --generate --cn Jan
+# Credential 2
+# [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1961]) <- [keyid:bob]
 
-stateU_keyid=`creddy --keyid --cert StateU_ID.pem`
+# Credential 3
+# [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1965]) <- [keyid:mark]
 
-bob_keyid=`creddy --keyid --cert Bob_ID.pem`
-mark_keyid=`creddy --keyid --cert Mark_ID.pem`
-joe_keyid=`creddy --keyid --cert Joe_ID.pem`
-maryann_keyid=`creddy --keyid --cert Maryann_ID.pem`
-jan_keyid=`creddy --keyid --cert Jan_ID.pem`
+# Credential 4
+# [keyid:stateU].role:diploma([string:'zoology'],[integer:1961]) <- [keyid:joe]
 
-diploma_q_qY="diploma([string:?D:['mathmatics','psychology']], [integer:?Year:[1960,1961,1963]])"
+# Credential 5
+# [keyid:stateU].role:diploma([string:'psychology'],[integer:1962]) <- [keyid:maryann]
 
-diploma_m="diploma([string:'mathmatics'],[integer:1961])"
-diploma_mm="diploma([string:'mathmatics'],[integer:1965])"
-diploma_z="diploma([string:'zoology'],[integer:1961])"
-diploma_p="diploma([string:'psychology'],[integer:1962])"
-diploma_pp="diploma([string:'psychology'],[integer:1960])"
+# Credential 6
+# [keyid:stateU].role:diploma([string:'psychology'],[integer:1960]) <- [keyid:jan]
 
-# [keyid:stateU].role:foundingAlumni 
-#                   <- [keyid:stateU].role:diploma([string:?D:['mathmatics','psychology']], [integer:?Year:[1960,1961,1963]])
-# Credential 1
-creddy --attribute \
-       --issuer StateU_ID.pem --key StateU_private.pem --role "foundingAlumni" \
-       --subject-cert StateU_ID.pem --subject-role "$diploma_q_qY" \
-       --out StateU_foundingAlumni__stateU_diploma_q_qY_attr.der
-
-# [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1961]) <- [keyid:bob]
-# Credential 2
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_m" \
-        --subject-cert Bob_ID.pem \
-        --out StateU_diploma_m__Bob_attr.der
-
-# [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1965]) <- [keyid:mark]
-# Credential 3
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_mm" \
-        --subject-cert Mark_ID.pem \
-        --out StateU_diploma_mm__Mark_attr.der
-
-# [keyid:stateU].role:diploma([string:'zoology'],[integer:1961]) <- [keyid:joe]
-# Credential 4
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_z" \
-        --subject-cert Joe_ID.pem \
-        --out StateU_diploma_z__Joe_attr.der
-
-# [keyid:stateU].role:diploma([string:'psychology'],[integer:1962]) <- [keyid:maryann]
-# Credential 5
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_p" \
-        --subject-cert Maryann_ID.pem \
-        --out StateU_diploma_p__Maryann_attr.der
-
-# [keyid:stateU].role:diploma([string:'psychology'],[integer:1960]) <- [keyid:jan]
-# Credential 6
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_pp" \
-        --subject-cert Jan_ID.pem \
-        --out StateU_diploma_pp__Jan_attr.der
-
Index: examples/python_tests/alumni3_rt1/attr.py
===================================================================
--- examples/python_tests/alumni3_rt1/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni3_rt1/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,8 +2,8 @@
 
 """
-  Setup access policy attribute rules
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
-
 """
 
@@ -11,10 +11,12 @@
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
 
 out = ctxt.context_principals()
@@ -30,4 +32,5 @@
 print "\n"
 
+# retrieve principals' keyid value from local credential files
 stateUID=ABAC.ID("StateU_ID.pem")
 stateUID.id_load_privkey_file("StateU_private.pem")
@@ -56,23 +59,44 @@
 
 ################################################
+# Credential 1, this policy has two range constraints on different parameters
 # [keyid:stateU].role:foundingAlumni
 #              <- [keyid:stateU].role:diploma([string:?D:['mathmatics','psychology']],
 #                                             [integer:?Year:[1960,1961,1963]])
 head = ABAC.Role(stateU,"foundingAlumni")
+
+# initialize a string range constraint
 cond=ABAC.Constraint("string")
+
+# add specific string values to the constraint
 cond.constraint_add_string_target("'mathmatics'")
 cond.constraint_add_string_target("'psychology'")
+
+# create the parameter with the string range constraint
 param1=ABAC.DataTerm("string", "D", cond)
+
+# initialize another constratnt that is of integer type
 cond=ABAC.Constraint("integer")
+
+# add specific integer values to the constraint
 cond.constraint_add_integer_target(1960)
 cond.constraint_add_integer_target(1961)
 cond.constraint_add_integer_target(1963)
+
+# create the parameter with the integer range constraint
 param2=ABAC.DataTerm("integer", "Year", cond)
 tail = ABAC.Role(stateU,"diploma")
+
+# add the parameter with conditions to a role
 tail.role_add_data_term(param1)
 tail.role_add_data_term(param2)
+
+# build up the policy rule
 attr=ABAC.Attribute(head, 1800)
 attr.attribute_add_tail(tail)
+
+# finalize the policy rule
 attr.attribute_bake()
+
+# save it to a credential file
 attr.attribute_write_cert("StateU_foundingAlumni__stateU_diploma_q_qY_attr.der")
 ctxt.load_attribute_file("StateU_foundingAlumni__stateU_diploma_q_qY_attr.der")
@@ -82,4 +106,5 @@
 
 #################################################
+# Credential 2
 # [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1961]) <- [keyid:bob]
 param1=ABAC.DataTerm("string", "'mathmatics'")
@@ -99,4 +124,5 @@
 
 #################################################
+# Credential 3
 # [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1965]) <- [keyid:mark]
 param1=ABAC.DataTerm("string", "'mathmatics'")
@@ -116,4 +142,5 @@
 
 #################################################
+# Credential 4
 # [keyid:stateU].role:diploma([string:'zoology'],[integer:1961]) <- [keyid:joe]
 param1=ABAC.DataTerm("string", "'zoology'")
@@ -133,5 +160,7 @@
 
 #################################################
-# [keyid:stateU].role:diploma([string:'psychology'],[integer:1962]) <- [keyid:maryann]
+# Credential 5
+# [keyid:stateU].role:diploma([string:'psychology'],[integer:1962])
+#                             <- [keyid:maryann]
 param1=ABAC.DataTerm("string", "'psychology'")
 param2=ABAC.DataTerm("integer", "1962")
@@ -151,5 +180,7 @@
 
 #################################################
-# [keyid:stateU].role:diploma([string:'psychology'],[integer:1960]) <- [keyid:jan]
+# Credential 6
+# [keyid:stateU].role:diploma([string:'psychology'],[integer:1960])
+#                              <- [keyid:jan]
 param1=ABAC.DataTerm("string", "'psychology'")
 param2=ABAC.DataTerm("integer", "1960")
@@ -167,5 +198,2 @@
 print "\n"
 
-
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/alumni3_rt1/query.py
===================================================================
--- examples/python_tests/alumni3_rt1/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni3_rt1/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -14,10 +14,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 stateUID=ABAC.ID("StateU_ID.pem")
 stateUID.id_load_privkey_file("StateU_private.pem")
@@ -43,4 +47,16 @@
 janID.id_load_privkey_file("Jan_private.pem")
 jan=janID.id_keyid()
+
+##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
 
 ##########################################################################
@@ -94,18 +110,2 @@
     print "%s <- %s" % (c.head_string(), c.tail_string())
 
-
-##########################################################################
-# dump the loaded principals/policies
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
-
-
Index: examples/python_tests/alumni3_rt1/run_test
===================================================================
--- examples/python_tests/alumni3_rt1/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni3_rt1/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,6 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
 
 echo '---setup principals'
Index: examples/python_tests/alumni3_rt1/setup.py
===================================================================
--- examples/python_tests/alumni3_rt1/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni3_rt1/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,6 +2,6 @@
 
 """
-  Setup 4 principal ID credentials
-
+See README for the semantics.  This creates many principals
+used by the example.
 """
 import os
Index: examples/python_tests/alumni_rt1/README
===================================================================
--- examples/python_tests/alumni_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,11 +1,11 @@
-#!/bin/sh
 #
-# This example shows an example of reasoning about a role's parameters.  There
-# are 4 principals StateU, Bob, Maryann, and Joe.  StateU wants to establish a
-# set of founding alumni based on the year of graduation.  On graduation each
-# alum has previously been issued a credential parameterized with their major
-# and graduation year.  StateU sets up a policy that says that a principal is a
-# founding alum if they graduated in 1955 through 1958 inclusive no matter what
-# major the principal had.  This policy is expressed in Credential 1.
+# This example shows an example of reasoning about a role's parameters with
+# a range constraint.  There are 4 principals StateU, Bob, Maryann, and Joe.
+# StateU wants to establish a  set of founding alum based on the year of 
+# graduation.  On graduation each alum has previously been issued a 
+# credential parameterized with their major and graduation year.  StateU 
+# sets up a policy that says that a principal is a founding alum if they 
+# graduated in 1955 through 1958 inclusive no matter what major the 
+# principal had.  This policy is expressed in Credential 1.
 #
 # Credentials 2, 3, and 4 each assign a diploma credential to Bob (a 1960
@@ -13,78 +13,19 @@
 # psychology degree).
 #
-# The attached ./run_query file asks if each of these principals are favored
+# The query.py file asks if each of these principals are favored
 # alums and Joe and Maryann are.
 
-# alumni_rt1_typed
+# alumni_rt1
 
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Bob] (no)
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Maryann] (yes)
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Joe] (yes)
-
-creddy --generate --cn StateU
-creddy --generate --cn Bob
-creddy --generate --cn Maryann
-creddy --generate --cn Joe
-
-stateU_keyid=`creddy --keyid --cert StateU_ID.pem`
-bob_keyid=`creddy --keyid --cert Bob_ID.pem`
-maryann_keyid=`creddy --keyid --cert Maryann_ID.pem`
-joe_keyid=`creddy --keyid --cert Joe_ID.pem`
-
-diploma_q_qY="diploma([?], [integer:?Year:[1955..1958]])"
-
-diploma_m="diploma([string:'mathmatics'],[integer:1960])"
-diploma_z="diploma([string:'zoology'],[integer:1955])"
-diploma_p="diploma([string:'psychology'],[integer:1956])"
-
+# Credential 1
 # [keyid:stateU].role:foundingAlumni 
 #                   <- [keyid:stateU].role:diploma([?], [integer:?Year:[1955..1958]])
-# Credential 1
-creddy --attribute \
-       --issuer StateU_ID.pem --key StateU_private.pem --role "foundingAlumni" \
-       --subject-cert StateU_ID.pem --subject-role "$diploma_q_qY" \
-       --out StateU_foundingAlumni__stateU_diploma_q_qY_attr.der
 
+# Credential 2
 # [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1960]) <- [keyid:bob]
-# Credential 2
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_m" \
-        --subject-cert Bob_ID.pem \
-        --out StateU_diploma_m__Bob_attr.der
 
+# Credential 3
 # [keyid:stateU].role:diploma([string:'zoology'],[integer:1955]) <- [keyid:joe]
-# Credential 3
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_z" \
-        --subject-cert Joe_ID.pem \
-        --out StateU_diploma_m__Joe_attr.der
 
+# Credential 4
 # [keyid:stateU].role:diploma([string:'psychology'],[integer:1956]) <- [keyid:maryann]
-# Credential 4
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_p" \
-        --subject-cert Maryann_ID.pem \
-        --out StateU_diploma_m__Maryann_attr.der
-
-
-#####################################################################
-# stateU.foundingAlumni <- stateU.diploma(?, ?Year:[1955..1958])
-# [keyid:stateU].role:foundingAlumni 
-#                <- [keyid:stateU].role:diploma([?], [integer:?Year:[1955..1958]])
-# 
-# stateU.diploma(mathmatics,1960)<-bob
-# [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1960]) <- [keyid:bob]
-# 
-# stateU.diploma(zoology,1955)<-joe
-# [keyid:stateU].role:diploma([string:'zoology'],[integer:1955]) <- [keyid:joe]
-#
-# stateU.diploma(psychology,1956)<-maryann
-# [keyid:stateU].role:diploma([string:'psychology'],[integer:1956]) <- [keyid:maryann]
-#
-# query,
-# stateU.foundingAlumni<-?-bob  bad
-# [keyid:stateU].role:foundingAlumni <- [keyid:bob]
-# 
-# stateU.foundingAlumni<-?-maryann  good
-# [keyid:stateU].role:foundingAlumni <- [keyid:maryann]
-#
Index: examples/python_tests/alumni_rt1/attr.py
===================================================================
--- examples/python_tests/alumni_rt1/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni_rt1/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,8 +2,8 @@
 
 """
-  Setup access policy attribute rules
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
-
 """
 
@@ -11,10 +11,12 @@
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
 
 out = ctxt.context_principals()
@@ -30,4 +32,5 @@
 print "\n"
 
+# retrieve principals' keyid value from local credential files
 stateUID=ABAC.ID("StateU_ID.pem")
 stateUID.id_load_privkey_file("StateU_private.pem")
@@ -48,11 +51,21 @@
 
 ################################################
+# Credential 1, the year is constrainted by a range constraint with min and max 
+#               values
 # [keyid:stateU].role:foundingAlumni
-#                   <- [keyid:stateU].role:diploma([?], [integer:?Year:[1955 .. 1958]])
+#          <- [keyid:stateU].role:diploma([?], [integer:?Year:[1955 .. 1958]])
 head = ABAC.Role(stateU,"foundingAlumni")
+
+# create an anonymous parameter that will take any type of major
 param1=ABAC.DataTerm("anonymous", "_")
+
+# initialize a constraint with integer type
 cond=ABAC.Constraint("integer")
+
+# set the bounding min and max value for this constraint
 cond.constraint_add_integer_min(1955)
 cond.constraint_add_integer_max(1958)
+
+# make the parameter with this integer constraint
 param2=ABAC.DataTerm("integer", "Year", cond)
 tail = ABAC.Role(stateU,"diploma")
@@ -60,7 +73,15 @@
 tail.role_add_data_term(param2)
 attr=ABAC.Attribute(head, 1800)
+
+# build up the policy
 attr.attribute_add_tail(tail)
+
+# finalize the policy
 attr.attribute_bake()
+
+# write the policy out into the file system
 attr.attribute_write_cert("StateU_foundingAlumni__stateU_diploma_q_qY_attr.der")
+
+# load this policy into the context using this external credential file
 ctxt.load_attribute_file("StateU_foundingAlumni__stateU_diploma_q_qY_attr.der")
 print attr.string() 
@@ -69,5 +90,7 @@
 
 #################################################
-# [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1960]) <- [keyid:bob]
+# Credential 2
+# [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1960]) 
+#                                                            <- [keyid:bob]
 param1=ABAC.DataTerm("string", "'mathmatics'")
 param2=ABAC.DataTerm("integer", "1960")
@@ -86,5 +109,7 @@
 
 #################################################
-# [keyid:stateU].role:diploma([string:'zoology'],[integer:1955]) <- [keyid:joe]
+# Credential 3
+# [keyid:stateU].role:diploma([string:'zoology'],[integer:1955]) 
+#                                                     <- [keyid:joe]
 param1=ABAC.DataTerm("string", "'zoology'")
 param2=ABAC.DataTerm("integer", "1955")
@@ -103,5 +128,7 @@
 
 #################################################
-# [keyid:stateU].role:diploma([string:'psychology'],[integer:1956]) <- [keyid:maryann]
+# Credential 4
+# [keyid:stateU].role:diploma([string:'psychology'],[integer:1956]) 
+#                                                   <- [keyid:maryann]
 param1=ABAC.DataTerm("string", "'psychology'")
 param2=ABAC.DataTerm("integer", "1956")
@@ -119,4 +146,2 @@
 print "\n"
 
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/alumni_rt1/query.py
===================================================================
--- examples/python_tests/alumni_rt1/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni_rt1/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -14,10 +14,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 stateUID=ABAC.ID("StateU_ID.pem")
 stateUID.id_load_privkey_file("StateU_private.pem")
@@ -37,4 +41,17 @@
 
 ##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
+# is bob a founding alumni of stateU ?
 # role=[keyid:stateU].role:foundingAlumni
 # p=[keyid:Bob] 
@@ -47,4 +64,5 @@
 
 ##########################################################################
+# is maryann a founding alumni of stateU ?
 # role=[keyid:stateU].role:foundingAlumni
 # p=[keyid:Maryann] 
@@ -57,4 +75,5 @@
 
 ##########################################################################
+# is joe a founding alumni of stateU ?
 # role=[keyid:stateU].role:foundingAlumni
 # p=[keyid:Joe] 
@@ -66,17 +85,2 @@
     print "%s <- %s" % (c.head_string(), c.tail_string())
 
-##########################################################################
-# dump the loaded principals/policies
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
-
-
Index: examples/python_tests/alumni_rt1/run_test
===================================================================
--- examples/python_tests/alumni_rt1/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni_rt1/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,6 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
 
 echo '---setup principals'
Index: examples/python_tests/alumni_rt1/setup.py
===================================================================
--- examples/python_tests/alumni_rt1/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni_rt1/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,7 +2,8 @@
 
 """
-  Setup 4 principal ID credentials
+See README for the semantics.  This creates principals
+used by the example.
+"""
 
-"""
 import os
 import ABAC
